/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LibNFS.xs. Do not edit this file, edit LibNFS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LibNFS.xs"
#include "easyxs/easyxs.h"

#include <stdbool.h>
#include <stdint.h>
#include <math.h>
#include <inttypes.h>

// For some reason sys/time.h causes funky arrow-pointer errors
// in Strawberry Perl …
#ifdef _WIN32
#   include <time.h>
#else
#   include <sys/time.h>
#endif

// Windows lacks poll.h; these come from libnfs’s compat header.
#ifndef POLLIN
#   ifdef _WIN32
#       define POLLIN 0x0001
#       define POLLOUT 0x0004
#   else
#       include <poll.h>
#   endif
#endif

#include <nfsc/libnfs.h>
#include <nfsc/libnfs-raw.h>
#include <nfsc/libnfs-raw-mount.h>

#ifndef F_RDLCK
#include <fcntl.h>

// Strawberry does *not* seem to provide F_RDLCK & friends, though.
#ifndef F_RDLCK
#define F_RDLCK 0
#define F_WRLCK 1
#define F_UNLCK 2
#endif
#endif

// Taken from libnfs itself:
#define UNIX_AUTHN_MACHINE_NAME "libnfs"

#define PERL_NS "Net::LibNFS"
#define PERL_STAT_NS PERL_NS "::Stat"
#define PERL_STATVFS_NS PERL_NS "::StatVFS"
#define PERL_FH_NS PERL_NS "::Filehandle"
#define PERL_DH_NS PERL_NS "::Dirhandle"
#define PERL_DIRENT_NS PERL_NS "::DirEnt"

#define PERL_ASYNC_NS PERL_NS "::Async"
#define PERL_FH_ASYNC_NS PERL_ASYNC_NS "::Filehandle"

#define OFFSET_OF(structtype, membername) ( \
    (void*) &( ((structtype*) NULL)->membername ) - NULL \
)

#define GET_STAT64_OFFSET(membername) \
    OFFSET_OF(struct nfs_stat_64, membername)

#define _FORBID_VOID_CONTEXT \
    if (GIMME_V == G_VOID) croak("Void context is forbidden!")

unsigned char STAT64_OFFSET[] = {
    GET_STAT64_OFFSET(nfs_dev),
    GET_STAT64_OFFSET(nfs_ino),
    GET_STAT64_OFFSET(nfs_mode),
    GET_STAT64_OFFSET(nfs_nlink),
    GET_STAT64_OFFSET(nfs_uid),
    GET_STAT64_OFFSET(nfs_gid),
    GET_STAT64_OFFSET(nfs_rdev),
    GET_STAT64_OFFSET(nfs_size),
    GET_STAT64_OFFSET(nfs_blksize),
    GET_STAT64_OFFSET(nfs_blocks),
    GET_STAT64_OFFSET(nfs_atime),
    GET_STAT64_OFFSET(nfs_mtime),
    GET_STAT64_OFFSET(nfs_ctime),
    GET_STAT64_OFFSET(nfs_atime_nsec),
    GET_STAT64_OFFSET(nfs_mtime_nsec),
    GET_STAT64_OFFSET(nfs_ctime_nsec),
    GET_STAT64_OFFSET(nfs_used),
};

#define GET_DIRENT_OFFSET(membername) \
    OFFSET_OF(struct nfsdirent, membername)

unsigned char DIRENT_OFFSET[] = {
    GET_DIRENT_OFFSET(next),
    GET_DIRENT_OFFSET(name),
    GET_DIRENT_OFFSET(inode),
    GET_DIRENT_OFFSET(type),
    GET_DIRENT_OFFSET(mode),
    GET_DIRENT_OFFSET(size),
    GET_DIRENT_OFFSET(atime),
    GET_DIRENT_OFFSET(mtime),
    GET_DIRENT_OFFSET(ctime),
    GET_DIRENT_OFFSET(uid),
    GET_DIRENT_OFFSET(gid),
    GET_DIRENT_OFFSET(nlink),
    GET_DIRENT_OFFSET(dev),
    GET_DIRENT_OFFSET(rdev),
    GET_DIRENT_OFFSET(blksize),
    GET_DIRENT_OFFSET(blocks),
    GET_DIRENT_OFFSET(used),
    GET_DIRENT_OFFSET(atime_nsec),
    GET_DIRENT_OFFSET(mtime_nsec),
    GET_DIRENT_OFFSET(ctime_nsec),
};

#define GET_STATVFS64_OFFSET(membername) \
    OFFSET_OF(struct nfs_statvfs_64, membername)

unsigned char STATVFS64_OFFSET[] = {
    GET_STATVFS64_OFFSET(f_bsize),
    GET_STATVFS64_OFFSET(f_frsize),
    GET_STATVFS64_OFFSET(f_blocks),
    GET_STATVFS64_OFFSET(f_bfree),
    GET_STATVFS64_OFFSET(f_bavail),
    GET_STATVFS64_OFFSET(f_files),
    GET_STATVFS64_OFFSET(f_ffree),
    GET_STATVFS64_OFFSET(f_favail),
    GET_STATVFS64_OFFSET(f_fsid),
    GET_STATVFS64_OFFSET(f_flag),
    GET_STATVFS64_OFFSET(f_namemax),
};

typedef struct {
    struct nfs_context *nfs;
    pid_t pid;
} nlnfs_s;

typedef struct {
    struct rpc_context *rpc;
    pid_t pid;
} nlnfs_rpc_s;

typedef struct {
    struct nfsfh *nfsfh;
    SV* perl_nfs;
    pid_t pid;
} nlnfs_fh_s;

typedef struct {
    struct nfsdir *nfsdh;    // not a pointer
    SV* perl_nfs;
    pid_t pid;
    bool closed;
} nlnfs_dh_s;

typedef SV* (*_cb_parser) (pTHX_ void*, const char*, int, void *, SV**, void*);

typedef struct {
#ifdef MULTIPLICITY
    tTHX aTHX;
#endif
    SV* cb;
    void* arg;
    const char* funcname;
    _cb_parser parser;
} perl_cb_s;

static SV* _ptr_to_perl_stat_obj (pTHX_ void *data) {
    SV* retval = exs_new_structref( struct nfs_stat_64, PERL_STAT_NS );
    StructCopy(data, exs_structref_ptr(retval), struct nfs_stat_64);

    return retval;
}

static SV* _ptr_to_perl_statvfs_obj (pTHX_ void *data) {
    SV* retval = exs_new_structref( struct nfs_statvfs_64, PERL_STATVFS_NS );
    StructCopy(data, exs_structref_ptr(retval), struct nfs_statvfs_64);

    return retval;
}

SV* _ptr_to_perl_dirent_obj(pTHX_ struct nfsdirent* dent) {
    SV* retval = exs_new_structref( struct nfsdirent, PERL_DIRENT_NS );
    StructCopy(dent, exs_structref_ptr(retval), struct nfsdirent);

    return retval;
}

static void __do_perl_callback_internal(
    void* nfs_or_rpc,
    int err,
    void *data,
    void *private_data
) {
    perl_cb_s* cb_sp = (perl_cb_s*) private_data;

#ifdef MULTIPLICITY
    tTHX aTHX = cb_sp->aTHX;
#endif

    SV* err_sv = NULL;

    SV* result = cb_sp->parser(aTHX_ nfs_or_rpc, cb_sp->funcname, err, data, &err_sv, cb_sp->arg);

    SV* args[] = {
        result,
        err_sv, // If NULL then this is identical to omitting
        NULL,
    };

    SV* error = NULL;

    exs_call_sv_void_trapped(cb_sp->cb, args, &error);

    SvREFCNT_dec(cb_sp->cb);

    Safefree(cb_sp);

    if (error) warn_sv(error);
}

static void _do_perl_rpc_callback (
    struct rpc_context* rpc,
    int status,
    void* data,
    void* private_data
) {

    return __do_perl_callback_internal(rpc, status, data, private_data);
}

static void _do_perl_callback (
    int err,
    struct nfs_context *nfs,
    void *data,
    void *private_data
) {
    return __do_perl_callback_internal(nfs, err, data, private_data);
}

// snagged from Net::Libwebsockets:
static SV* _create_err_obj (pTHX_ const char* type, unsigned argscount, ...) {

    // If argscount == 1:
    //  create_args[0] is the type
    //  create_args[1] is the arg
    //  create_args[2] is NULL

    SV* create_args[argscount+2];
    create_args[0] = newSVpv(type, 0);
    create_args[argscount+1] = NULL;

    va_list args;
    va_start(args, argscount);

    for (unsigned a=0; a<argscount; a++) {
        create_args[a+1] = va_arg(args, SV*);
    }

    va_end(args);

    SV* x_class_sv = newSVpvs(PERL_NS "::X");

    load_module(PERL_LOADMOD_NOIMPORT, newSVsv(x_class_sv), NULL);

    return exs_call_method_scalar(
        sv_2mortal(x_class_sv),
        "create",
        create_args
    );
}

static SV* _create_nfs_errno (pTHX_ struct nfs_context* nfs, const char* funcname, int error, const char* errstr) {

    const char* errstr2 = errstr ? errstr : nfs_get_error(nfs);

    return _create_err_obj(aTHX_ "NFSError", 3,
        newSVpv(funcname, 0),
        newSViv(-error),
        newSVpv(errstr2, 0)
    );
}

static SV* _create_rpc_errno (pTHX_ struct rpc_context* rpc, const char* funcname, int error, const char* errstr) {

    const char* errstr2 = errstr ? errstr : rpc_get_error(rpc);

    return _create_nfs_errno(aTHX_ NULL, funcname, error, errstr2);
}

static void _croak_nfs_errno (pTHX_ struct nfs_context* nfs, const char* funcname, int error, const char* errstr) {

    const char* str = errstr ? errstr : nfs_get_error(nfs);

    croak_sv( _create_nfs_errno(aTHX_ nfs, funcname, error, str) );
}

unsigned _count_exports( struct exportnode* node ) {
    unsigned h=0;

    while (node) {
        h++;
        node = node->ex_next;
    }

    return h;
}

void _parse_exports_to_hrs( pTHX_ struct exportnode* nodes, SV** export_hrs ) {
    unsigned h=0;

    struct exportnode* node = nodes;
    while (node) {
        SV* path = newSVpv(node->ex_dir, 0);

        AV* groups_av = newAV();

        groupnode* curgroup = node->ex_groups;
        while (curgroup) {
            SV* name = newSVpv(curgroup->gr_name, 0);
            av_push(groups_av, name);

            curgroup = curgroup->gr_next;
        }

        HV* export_hv = newHV();
        hv_stores(export_hv, "dir", path);
        hv_stores(export_hv, "groups", newRV_noinc((SV*) groups_av));

        export_hrs[h] = newRV_noinc((SV*) export_hv);

        node = node->ex_next;
    }
}

// ----------------------------------------------------------------------

static struct timeval _parse_time_sv (pTHX_ SV* time_sv) {
    time_t secs;
    useconds_t microsecs;

    if (SvROK(time_sv)) {
        bool ok = false;

        SV* referent = SvRV(time_sv);

        if (SvTYPE(referent) == SVt_PVAV) {
            AV* times_arr = (AV*) referent;

            if (av_tindex(times_arr) == 1) {
                secs = exs_SvUV( *(av_fetch(times_arr, 0, 0)) );
                microsecs = exs_SvUV( *(av_fetch(times_arr, 1, 0)) );
                ok = true;
            }
        }

        if (!ok) {
            croak("%" SVf " must be either a nonnegative number or an arrayref of 2 nonnegative integers", time_sv);
        }
    }
    else if (SvIOK(time_sv)) {
        IV floatval = SvIV(time_sv);

        if (floatval < 0) croak("Time (%" IVdf " must be positive!", floatval);

        secs = floatval;
        microsecs = 0;
    }
    else {
        NV floatval = SvNV(time_sv);

        if (floatval < 0) croak("Time (%" NVff " must be positive!", floatval);

        secs = floor(floatval);
        microsecs = floatval * 1000000;
    }

    return (struct timeval) {
        .tv_sec = secs,
        .tv_usec = microsecs,
    };
}

// ----------------------------------------------------------------------

union fcntl_arg {
    struct nfs4_flock flock;
};

static inline void _set_fcntl_arg (pTHX_ enum nfs4_fcntl_op cmd, union fcntl_arg* arg, SV** args, unsigned argslen) {

    *arg = (union fcntl_arg) {
        .flock = { 0 },
    };

    unsigned argsmin;
    unsigned argsmax;

    switch (cmd) {
        case NFS4_F_SETLK:
        case NFS4_F_SETLKW:
            argsmin = 2;
            argsmax = 4;

            arg->flock.l_type = SvIV(args[0]);    // TODO: strict
            arg->flock.l_whence = SvIV(args[1]);

            if (argslen > 2) {

                /* It’s unclear why l_start is uint64_t rather than int64_t
                   since fcntl(2) defines it as off_t (i.e., signed).
                */
                arg->flock.l_start = exs_SvUV(args[2]);

                if (argslen > 3) {
                    arg->flock.l_len = exs_SvUV(args[3]);
                }
            }

        default:
            croak("%s: Unknown op: %u", __func__, cmd);
            assert(0);
    }

    // We assume an extra arg for the command (e.g., NFS4_F_SETLK).

    if (argsmin > argslen) {
        croak("Need at least %u args; got %d", 1 + argsmin, 1 + argslen);
    }
    else if (argsmax < argslen) {
        croak("Need at most %u args; got %d", 1 + argsmax, 1 + argslen);
    }
}

// ----------------------------------------------------------------------

static SV* _create_perl_fh(pTHX_ SV* self_sv, struct nfsfh* nfsfh) {
    SV* retval = exs_new_structref(nlnfs_fh_s, PERL_FH_NS);
    nlnfs_fh_s* perl_nfs_fh = exs_structref_ptr(retval);

    *perl_nfs_fh = (nlnfs_fh_s) {
        .nfsfh = nfsfh,
        .perl_nfs = SvREFCNT_inc(self_sv),
        .pid = getpid(),
    };

    return retval;
}

static SV* _create_perl_dh(pTHX_ SV* self_sv, struct nfsdir *nfsdh) {
    SV* retval = exs_new_structref(nlnfs_dh_s, PERL_DH_NS);
    nlnfs_dh_s* perl_nfs_dh = exs_structref_ptr(retval);

    *perl_nfs_dh = (nlnfs_dh_s) {
        .nfsdh = nfsdh,
        .perl_nfs = SvREFCNT_inc(self_sv),
        .pid = getpid(),
    };

    return retval;
}

// ----------------------------------------------------------------------

static SV* _parse_mount_getexports (pTHX_ void* rpc, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    SV* retval;

    if (err) {
        *err_sv = _create_rpc_errno(aTHX_ rpc, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        struct exportnode* node0 = *(exports *)data;
        unsigned count = _count_exports(node0);

        SV* export_hrs[count];

        _parse_exports_to_hrs(aTHX_ node0, export_hrs);

        AV* ret_av = newAV();
        av_extend(ret_av, count-1);

        for (unsigned c=0; c<count; c++) {
            av_store(ret_av, c, export_hrs[c]);
        }

        retval = newRV_noinc( (SV*) ret_av );
    }

    return retval;
}

static SV* _parse_readlink_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    SV* retval;

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        retval = newSVpv(data, 0);
    }

    return retval;
}

static SV* _parse_fallible_empty_return (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
    }

    return &PL_sv_undef;
}

static SV* _parse_stat64_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    SV* retval;

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        assert(data);
        retval = _ptr_to_perl_stat_obj(aTHX_ data);
    }

    return retval;
}

static SV* _parse_statvfs64_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    SV* retval;

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        assert(data);
        retval = _ptr_to_perl_statvfs_obj(aTHX_ data);
    }

    return retval;
}

static SV* _parse_open_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    SV* perl_nfs_sv = arg;

    SV* retval;

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        assert(data);
        retval = _create_perl_fh(aTHX_ perl_nfs_sv, data);
    }

    SvREFCNT_dec(perl_nfs_sv);

    return retval;
}

static SV* _parse_opendir_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    SV* perl_nfs_sv = arg;

    SV* retval;

    if (err) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        assert(data);
        retval = _create_perl_dh(aTHX_ perl_nfs_sv, data);
    }

    SvREFCNT_dec(perl_nfs_sv);

    return retval;
}

static SV* _parse_read_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    PERL_UNUSED_ARG(arg);

    SV* retval;

    if (err < 0) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        assert(data);

        retval = newSVpvn(data, err);
    }

    return retval;
}

static SV* _parse_write_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    SV* retval;

    if (err < 0) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        retval = newSViv(err);
    }

    return retval;
}

static SV* _parse_lseek_async (pTHX_ void* nfs, const char* funcname, int err, void *data, SV** err_sv, void* arg) {
    SV* retval;

    if (err < 0) {
        *err_sv = _create_nfs_errno(aTHX_ nfs, funcname, err, data);
        retval = &PL_sv_undef;
    }
    else {
        uint64_t *pos_p = data;
        retval = newSVuv(*pos_p);
    }

    return retval;
}

// ----------------------------------------------------------------------

typedef void (*_lnfs_string_setter) (struct nfs_context*, const char*);

typedef struct {
    const char* name;
    _lnfs_string_setter func;
} _string_setting_s;

static const _string_setting_s STRING_SETTINGS[] = {
#ifdef HAVE_SO_BINDTODEVICE
    { .name = "interface", .func = nfs_set_interface },
#endif
    { .name = "client_name", .func = nfs4_set_client_name },
    { .name = "verifier", .func = nfs4_set_verifier },
};

static const unsigned STRING_SETTINGS_COUNT = sizeof(STRING_SETTINGS) / sizeof(_string_setting_s);

// ----------------------------------------------------------------------

typedef void (*_lnfs_int_setter) (struct nfs_context*, int);

typedef struct {
    const char* name;
    _lnfs_int_setter func;
} _int_setting_s;

static const _int_setting_s INT_SETTINGS[] = {
    { .name = "tcp_syncnt", .func = nfs_set_tcp_syncnt },
    { .name = "debug", .func = nfs_set_debug },
#ifdef NLNFS_NFS_SET_AUTO_TRAVERSE_MOUNTS
    { .name = "auto_traverse_mounts", .func = nfs_set_auto_traverse_mounts },
#endif
    { .name = "dircache", .func = nfs_set_dircache },
    { .name = "autoreconnect", .func = nfs_set_autoreconnect },
    { .name = "timeout", .func = nfs_set_timeout },
#ifdef NLNFS_NFS_SET_NFSPORT
    { .name = "nfsport", .func = nfs_set_nfsport },
#endif
#ifdef NLNFS_NFS_SET_MOUNTPORT
    { .name = "mountport", .func = nfs_set_mountport },
#endif
};

static const unsigned INT_SETTINGS_COUNT = sizeof(INT_SETTINGS) / sizeof(_int_setting_s);

// ----------------------------------------------------------------------

typedef void (*_lnfs_u32_setter) (struct nfs_context*, uint32_t);

typedef struct {
    const char* name;
    _lnfs_u32_setter func;
} _u32_setting_s;

static const _u32_setting_s U32_SETTINGS[] = {
    { .name = "uid", .func = (_lnfs_u32_setter) nfs_set_uid },
    { .name = "gid", .func = (_lnfs_u32_setter) nfs_set_gid },
    { .name = "pagecache", .func = nfs_set_pagecache },
    { .name = "pagecache_ttl", .func = nfs_set_pagecache_ttl },
    { .name = "readahead", .func = nfs_set_readahead },
};

static const unsigned U32_SETTINGS_COUNT = sizeof(U32_SETTINGS) / sizeof(_u32_setting_s);

// ----------------------------------------------------------------------

typedef void (*_lnfs_u64_setter) (struct nfs_context*, uint64_t);

typedef struct {
    const char* name;
    _lnfs_u64_setter func;
} _u64_setting_s;

static const _u64_setting_s U64_SETTINGS[] = {
    { .name = "readmax", .func = nfs_set_readmax },
    { .name = "writemax", .func = nfs_set_writemax },
};

static const unsigned U64_SETTINGS_COUNT = sizeof(U64_SETTINGS) / sizeof(_u64_setting_s);

// ----------------------------------------------------------------------

perl_cb_s* _create_callback_struct (pTHX_ const char* funcname, SV* cb, _cb_parser parser, void* arg) {
    perl_cb_s* cb_sp;
    Newx(cb_sp, 1, perl_cb_s);

    *cb_sp = (perl_cb_s) {
#ifdef MULTIPLICITY
        .aTHX = aTHX,
#endif
        .cb = SvREFCNT_inc(cb),
        .funcname = funcname,
        .parser = parser,
        .arg = arg,
    };

    return cb_sp;
}

// ----------------------------------------------------------------------

typedef int (*_nfs_statfunc) (struct nfs_context*, const char*, struct nfs_stat_64*);

SV* _stat_path_xsub (pTHX_ SV* self_sv, SV* path_sv, _nfs_statfunc func, const char* funcname) {
    nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
    struct nfs_stat_64 st;

    const char* path = exs_SvPVbyte_nolen(path_sv);

    int err = func( perl_nfs->nfs, path, &st );

    if (err) {
        _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
    }

    return _ptr_to_perl_stat_obj(aTHX_ &st);
}

// ----------------------------------------------------------------------

typedef int (*_nfs_void_pathfunc) (struct nfs_context*, const char*);
typedef int (*_nfs_async_void_pathfunc) (struct nfs_context*, const char*, nfs_cb, void*);

static _nfs_void_pathfunc VOID_PATHFUNC_BY_IX[] = {
    nfs_rmdir,
    nfs_chdir,
    nfs_unlink,
};

static _nfs_async_void_pathfunc ASYNC_VOID_PATHFUNC_BY_IX[] = {
    nfs_rmdir_async,
    nfs_chdir_async,
    nfs_unlink_async,
};

const char* VOID_PATHFUNC_NAME_BY_IX[] = {
    "rmdir",
    "chdir",
    "unlink",
};

typedef int (*_nfs_void_2pathfunc) (struct nfs_context*, const char*, const char*);
typedef int (*_nfs_async_void_2pathfunc) (struct nfs_context*, const char*, const char*, nfs_cb, void*);

static _nfs_void_2pathfunc VOID_2PATHFUNC_BY_IX[] = {
    nfs_symlink,
    nfs_rename,
    nfs_link,
};

static _nfs_async_void_2pathfunc ASYNC_VOID_2PATHFUNC_BY_IX[] = {
    nfs_symlink_async,
    nfs_rename_async,
    nfs_link_async,
};

const char* VOID_2PATHFUNC_NAME_BY_IX[] = {
    "symlink",
    "rename",
    "link",
};

// ----------------------------------------------------------------------

static inline void _croak_if_buffer_is_reference( pTHX_ SV* buf_sv ) {
    if (SvROK(buf_sv)) {
        croak("Given buffer must be a plain scalar, not %" SVf, buf_sv);
    }
}

#define _croak_if_uv_exceeds_u32(name, value) \
    if (value > UINT32_MAX) croak("%s: value (%" UVuf ") exceeds maximum (%" PRIu32 ")", name, value, UINT32_MAX);

// ----------------------------------------------------------------------

static void _utime_ish (pTHX_ int ix, SV* self_sv, SV* path_sv, SV* atime_sv, SV* mtime_sv, SV* cb) {
    nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

    const char* path = exs_SvPVbyte_nolen(path_sv);
    struct timeval times_arr[] = {
        _parse_time_sv(aTHX_ atime_sv),
        _parse_time_sv(aTHX_ mtime_sv),
    };

    int err;

    const char* funcname = ix ? "lutimes" : "utimes";

    if (cb) {
        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        if (ix) {
            err = nfs_lutimes_async(perl_nfs->nfs, path, times_arr, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_utimes_async(perl_nfs->nfs, path, times_arr, _do_perl_callback, cb_sp);
        }
    }
    else if (ix) {
        err = nfs_lutimes(perl_nfs->nfs, path, times_arr);
    }
    else {
        err = nfs_utimes(perl_nfs->nfs, path, times_arr);
    }

    if (err) {
        _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
    }

    return;
}

static SV* _read_or_pread (pTHX_ SV* self_sv, SV* offset_sv, SV* count_sv, SV* cb) {

    uint64_t count = exs_SvUV(count_sv);
    if (count < 1) croak("Count (%" SVf ") must be positive!", count_sv);

    uint64_t offset;
    if (offset_sv) offset = exs_SvUV(offset_sv);

    nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

    SV* nfs_sv = nfs_fh->perl_nfs;

    nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

    const char* funcname = offset_sv ? "pread" : "read";

    SV* RETVAL;
    int status;

    if (cb) {
        RETVAL = NULL;

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_read_async, NULL);

        if (offset_sv) {
            status = nfs_pread_async(perl_nfs->nfs, nfs_fh->nfsfh, offset, count, _do_perl_callback, cb_sp);
        }
        else {
            status = nfs_read_async(perl_nfs->nfs, nfs_fh->nfsfh, count, _do_perl_callback, cb_sp);
        }
    }
    else {
        RETVAL = newSV(count);
        SvPOK_on(RETVAL);

        void *buf = SvPVX(RETVAL);

        if (offset_sv) {
            status = nfs_pread(perl_nfs->nfs, nfs_fh->nfsfh, offset, count, buf);
        }
        else {
            status = nfs_read(perl_nfs->nfs, nfs_fh->nfsfh, count, buf);
        }
    }

    if (status < 0) {
        if (RETVAL) sv_2mortal(RETVAL);
        _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, status, NULL);
    }

    if (!cb) {
        assert(status <= count);

        if (status != count) {
            char* p = SvPVX(RETVAL);
            p[status] = '\0';
        }

        SvCUR_set(RETVAL, status);
    }

    return RETVAL;
}

// offset_sv == NULL iff write
// cb == NULL iff sync
//
static int _write_or_pwrite (pTHX_ SV* self_sv, SV* offset_sv, SV* buf_sv, SV* cb) {
    _croak_if_buffer_is_reference(aTHX_ buf_sv);

    uint64_t offset;
    if (offset_sv) offset = exs_SvUV(offset_sv);

    nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

    SV* nfs_sv = nfs_fh->perl_nfs;

    nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

    STRLEN buflen;
    const char* buf = SvPVbyte(buf_sv, buflen);

    if (buflen == 0) croak("Given buffer must be nonempty");

    int RETVAL;

    const char *funcname = offset_sv ? "pwrite" : "write";

    if (cb) {
        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_write_async, NULL);

        if (offset_sv) {
            RETVAL = nfs_pwrite_async(perl_nfs->nfs, nfs_fh->nfsfh, offset, buflen, buf, _do_perl_callback, cb_sp);
        }
        else {
            RETVAL = nfs_write_async(perl_nfs->nfs, nfs_fh->nfsfh, buflen, buf, _do_perl_callback, cb_sp);
        }
    }
    else if (offset_sv) {
        RETVAL = nfs_pwrite(perl_nfs->nfs, nfs_fh->nfsfh, offset, buflen, buf);
    }
    else {
        RETVAL = nfs_write(perl_nfs->nfs, nfs_fh->nfsfh, buflen, buf);
    }

    if (RETVAL < 0) {
        _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, RETVAL, NULL);
    }

    return RETVAL;
}

// NB: libnfs 5.0.2 added the ability to set auxiliary GIDs, which would
// obviate this functionality; however, by retaining it we allow pre-5.0.2
// libnfs releases to set aux GIDs. So there’s little incentive to adopt
// libnfs’s new hotness.
//
static void _set_unix_authn(pTHX_ struct nfs_context* nfs, SV* value_sv) {

    if (!SvROK(value_sv) || (SvTYPE(SvRV(value_sv)) != SVt_PVAV)) {
        croak("“%s” must be an array reference, not %" SVf, "unix_authn", value_sv);
    }

    AV* authn_av = (AV*) SvRV(value_sv);
    uint32_t nums_count = 1 + av_len(authn_av);
    if (nums_count < 2) croak("“%s” must contain at least 2 numbers", "unix_authn");

    uint32_t nums[nums_count];

    for (unsigned n=0; n<nums_count; n++) {
        SV** svp = av_fetch(authn_av, n, 0);
        assert(svp);

        UV value = exs_SvUV(*svp);

        // The RPC protocol transmits these values using 4 bytes.
        // Thus, u32 is the maximum, despite libnfs’s use of plain int
        // for these values.
        //
        _croak_if_uv_exceeds_u32("unix_authn", value);

        nums[n] = value;
    }

    struct AUTH* auth = libnfs_authunix_create(UNIX_AUTHN_MACHINE_NAME, nums[0], nums[1], nums_count - 2, 2 + nums);
    assert(auth);

    nfs_set_auth(nfs, auth);
}

#ifdef NLNFS_NFS_SET_READDIR_MAX_BUFFER_SIZE

#define MAX_BUFFER_SIZE_ARRAY_SIZE 2
#define READDIR_BUFFER_SETTING "readdir_buffer"

static void _set_readdir_max_buffer_size(pTHX_ struct nfs_context* nfs, SV* value_sv) {

    uint32_t dircount, maxcount;

    if (SvROK(value_sv) && (SvTYPE(SvRV(value_sv)) == SVt_PVAV)) {
        AV* av = (AV*) SvRV(value_sv);
        uint32_t nums_count = 1 + av_len(av);
        if (nums_count != MAX_BUFFER_SIZE_ARRAY_SIZE) croak("“%s” must contain exactly %d numbers", READDIR_BUFFER_SETTING, MAX_BUFFER_SIZE_ARRAY_SIZE);

        uint32_t nums[MAX_BUFFER_SIZE_ARRAY_SIZE];

        for (unsigned n=0; n<nums_count; n++) {
            SV** svp = av_fetch(av, n, 0);
            assert(svp);

            UV value = exs_SvUV(*svp);
            _croak_if_uv_exceeds_u32(READDIR_BUFFER_SETTING, value);

            nums[n] = value;
        }

        dircount = nums[0];
        maxcount = nums[1];
    } else if (SvROK(value_sv)) {
        croak("“%s” must be an array reference or scalar, not %" SVf, READDIR_BUFFER_SETTING, value_sv);
    } else {
        UV value = exs_SvUV(value_sv);
        _croak_if_uv_exceeds_u32(READDIR_BUFFER_SETTING, value);

        dircount = value;
        maxcount = value;
    }

    nfs_set_readdir_max_buffer_size(nfs, dircount, maxcount);
}
#endif

// ----------------------------------------------------------------------

#line 1052 "LibNFS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1196 "LibNFS.c"

XS_EUPXS(XS_Net__LibNFS_find_local_servers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_find_local_servers)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1061 "LibNFS.xs"
        struct nfs_server_list *servers = nfs_find_local_servers();

        if (!servers) {
            XSRETURN_EMPTY;
        }

        struct nfs_server_list *srvlist = servers;
        struct nfs_server_list *cur_srv = srvlist;

        unsigned srvcount = 0;

        while (cur_srv) {
            srvcount++;
            cur_srv = cur_srv->next;
        }

        cur_srv = srvlist;

        if (srvcount) {
            EXTEND(SP, srvcount);

            while (cur_srv) {
                mPUSHs( newSVpv(cur_srv->addr, 0) );
                cur_srv = cur_srv->next;
            }
        }

        free_nfs_srvr_list(srvlist);
#line 1236 "LibNFS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LibNFS_mount_getexports); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_mount_getexports)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "server_sv, timeout_sv=&PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	server_sv = ST(0)
;
	SV*	timeout_sv;

	if (items < 2)
	    timeout_sv = &PL_sv_undef;
	else {
	    timeout_sv = ST(1)
;
	}
#line 1093 "LibNFS.xs"
        const char* server = exs_SvPVbyte_nolen(server_sv);

        struct exportnode* nodes;

        if (SvOK(timeout_sv)) {
            int timeout = SvIV(timeout_sv); // TODO
            nodes = mount_getexports_timeout(server, timeout);
        }
        else {
            nodes = mount_getexports(server);
        }

        if (!nodes) {
            XSRETURN_EMPTY;
        }

        unsigned exports_count = _count_exports(nodes);
        SV* export_hrs[exports_count];

        _parse_exports_to_hrs( aTHX_ nodes, export_hrs );

        mount_free_export_list(nodes);
#line 1285 "LibNFS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LibNFS_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "classname");
    {
	SV *	RETVAL;
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
#line 1121 "LibNFS.xs"
        struct nfs_context *nfs = nfs_init_context();
        if (NULL == nfs) {
            croak("Failed to init libnfs context");
        }

        RETVAL = exs_new_structref(nlnfs_s, classname);
        nlnfs_s* perl_nfs = exs_structref_ptr(RETVAL);

        *perl_nfs = (nlnfs_s) {
            .nfs = nfs,
            .pid = getpid(),
        };

#line 1316 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV*	self_sv = ST(0)
;
#line 1140 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        if (perl_nfs->pid == getpid() && PL_dirty) {
            warn("%" SVf ": DESTROY at global destruction; memory leak likely!\n", self_sv);
        }

        assert(perl_nfs);
        assert(perl_nfs->nfs);

        nfs_destroy_context(perl_nfs->nfs);
#line 1344 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_set)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self_sv, ...");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 1154 "LibNFS.xs"
        if (!(items % 2)) {
            IV items_iv = items;
            croak("Uneven args list (%" IVdf " args) given!", items_iv-1);
        }

        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        unsigned a=1;
        for (; a<items; a++) {
            const char* param = exs_SvPVbyte_nolen(ST(a));

            SV* value_sv = ST(++a);

            // int --------------------------------------------------

            unsigned ss;

            for (ss=0; ss<INT_SETTINGS_COUNT; ss++) {
                if (strcmp(param, INT_SETTINGS[ss].name)) continue;

                int value = SvIV(value_sv);

                INT_SETTINGS[ss].func(perl_nfs->nfs, value);

                break;
            }

            if (ss != INT_SETTINGS_COUNT) continue;

            // uint32_t --------------------------------------------------

            for (ss=0; ss<U32_SETTINGS_COUNT; ss++) {
                if (strcmp(param, U32_SETTINGS[ss].name)) continue;

                UV value = exs_SvUV(value_sv);

                _croak_if_uv_exceeds_u32(param, value);

                U32_SETTINGS[ss].func(perl_nfs->nfs, value);

                break;
            }

            if (ss != U32_SETTINGS_COUNT) continue;

            // uint64_t --------------------------------------------------

            for (ss=0; ss<U64_SETTINGS_COUNT; ss++) {
                if (strcmp(param, U64_SETTINGS[ss].name)) continue;

                UV value = exs_SvUV(value_sv);

                U64_SETTINGS[ss].func(perl_nfs->nfs, value);

                break;
            }

            if (ss != U64_SETTINGS_COUNT) continue;

            // special --------------------------------------------------

            if (!strcmp(param, "version")) {
                int value = SvIV(value_sv);
                int err = nfs_set_version(perl_nfs->nfs, value);

                if (err) {
                    croak_sv( _create_err_obj(aTHX_ "Generic", 1,
                        newSVpv(nfs_get_error(perl_nfs->nfs), 0) )
                    );
                }

                continue;
            }

            if (!strcmp(param, "unix_authn")) {
                _set_unix_authn(aTHX_ perl_nfs->nfs, value_sv);

                continue;
            }
#ifdef NLNFS_NFS_SET_READDIR_MAX_BUFFER_SIZE

            if (!strcmp(param, READDIR_BUFFER_SETTING)) {
                _set_readdir_max_buffer_size(aTHX_ perl_nfs->nfs, value_sv);

                continue;
            }
#endif

            // string --------------------------------------------------

            for (ss=0; ss<STRING_SETTINGS_COUNT; ss++) {
                if (strcmp(param, STRING_SETTINGS[ss].name)) continue;

                const char* value = exs_SvPVbyte_nolen(value_sv);

                STRING_SETTINGS[ss].func(perl_nfs->nfs, value);

                break;
            }

            if (ss == STRING_SETTINGS_COUNT) {
                croak("Unknown setting: %s", param);
            }
        }

        RETVAL = SvREFCNT_inc(self_sv);

#line 1468 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_queue_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_queue_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1267 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        RETVAL = nfs_queue_length( perl_nfs->nfs );
#line 1490 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_get_readmax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_get_readmax)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	uint64_t	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1275 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        RETVAL = nfs_get_readmax( perl_nfs->nfs );
#line 1512 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_get_writemax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_get_writemax)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	uint64_t	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1283 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        RETVAL = nfs_get_writemax( perl_nfs->nfs );
#line 1534 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_get_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1291 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        RETVAL = nfs_get_version( perl_nfs->nfs );
#line 1556 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_umask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_umask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, new");
    {
	UV	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	SV*	new = ST(1)
;
#line 1301 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        UV new_uv = exs_SvUV(new);
        if (new_uv > UINT16_MAX) {
            croak("Invalid umask (%" UVuf ") given", new_uv);
        }

        RETVAL = nfs_umask(perl_nfs->nfs, new_uv);
#line 1585 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_mount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_mount)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, server_sv, exportname_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	server_sv = ST(1)
;
	SV*	exportname_sv = ST(2)
;
#line 1316 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* server = exs_SvPVbyte_nolen(server_sv);
        const char* exportname = exs_SvPVbyte_nolen(exportname_sv);

        int error = nfs_mount(perl_nfs->nfs, server, exportname);

        if (error) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "mount", error, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 1620 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_mount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_mount)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, server_sv, exportname_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	server_sv = ST(1)
;
	SV*	exportname_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 1334 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* server = exs_SvPVbyte_nolen(server_sv);
        const char* exportname = exs_SvPVbyte_nolen(exportname_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "mount", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_mount_async(perl_nfs->nfs, server, exportname, _do_perl_callback, cb_sp);
        if (err) croak("%s failed!", "nfs_mount_async");
#line 1653 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_umount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_umount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 1347 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        int error = nfs_umount(perl_nfs->nfs);

        if (error) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "umount", error, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 1679 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_umount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_umount)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	cb = ST(1)
;
#line 1362 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "umount", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_umount_async(perl_nfs->nfs, _do_perl_callback, cb_sp);
        if (err) croak("%s failed!", "nfs_umount_async");
#line 1705 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_stat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, path_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
#line 1374 "LibNFS.xs"
        RETVAL = _stat_path_xsub(aTHX_
            self_sv, path_sv,
            ix ? nfs_lstat64 : nfs_stat64,
            ix ? "lstat" : "stat"
        );

#line 1731 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_stat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 1388 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ ix ? "lstat" : "stat", cb, _parse_stat64_async, NULL);

        int err;
        if (ix) {
            err = nfs_lstat64_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_stat64_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);
        }

        if (err) croak("%s failed!", ix ? "nfs_lstat64_async" : "nfs_stat64_async");
#line 1769 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_open)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "self_sv, path_sv, flags_sv, mode_sv=&PL_sv_undef");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	flags_sv = ST(2)
;
	SV*	mode_sv;

	if (items < 4)
	    mode_sv = &PL_sv_undef;
	else {
	    mode_sv = ST(3)
;
	}
#line 1409 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int flags = SvIV(flags_sv); // TODO: stricter

        struct nfsfh* nfsfh;

        int err;

        if (SvOK(mode_sv)) {
            int mode = SvIV(mode_sv);   // TODO: stricter
            err = nfs_open2(perl_nfs->nfs, path, flags, mode, &nfsfh);
        }
        else {
            err = nfs_open(perl_nfs->nfs, path, flags, &nfsfh);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "open", err, NULL);
        }

        RETVAL = _create_perl_fh(aTHX_ self_sv, nfsfh);

#line 1821 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_open)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self_sv, path_sv, flags_sv, mode_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	flags_sv = ST(2)
;
	SV*	mode_sv = ST(3)
;
	SV*	cb = ST(4)
;
#line 1438 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int flags = SvIV(flags_sv); // TODO: stricter

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "open", cb, _parse_open_async, self_sv);

        int err;

        if (SvOK(mode_sv)) {
            int mode = SvIV(mode_sv);   // TODO: stricter
            err = nfs_open2_async(perl_nfs->nfs, path, flags, mode, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_open_async(perl_nfs->nfs, path, flags, _do_perl_callback, cb_sp);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "open", err, NULL);
        }

        // Increment self_sv’s refcount because it’s part of
        // the callback struct. _parse_open_async() will free this up.
        SvREFCNT_inc(self_sv);
#line 1871 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_mkdir)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv=&PL_sv_undef");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv;

	if (items < 3)
	    mode_sv = &PL_sv_undef;
	else {
	    mode_sv = ST(2)
;
	}
#line 1466 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        int err;

        if (SvOK(mode_sv)) {
            int mode = SvIV(mode_sv);   // TODO: stricter
            err = nfs_mkdir2(perl_nfs->nfs, path, mode);
        }
        else {
            err = nfs_mkdir(perl_nfs->nfs, path);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "mkdir", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);

#line 1918 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_mkdir)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 1492 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        int err;

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "mkdir", cb, _parse_fallible_empty_return, NULL);

        char* funcname;

        if (SvOK(mode_sv)) {
            int mode = SvIV(mode_sv);   // TODO: stricter
            err = nfs_mkdir2_async(perl_nfs->nfs, path, mode, _do_perl_callback, cb_sp);
            funcname = "nfs_mkdir2_async";
        }
        else {
            err = nfs_mkdir_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);
            funcname = "nfs_mkdir_async";
        }

        if (err) croak("%s failed!", funcname);
#line 1963 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_rmdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_rmdir)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, path_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
#line 1520 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        _nfs_void_pathfunc func = VOID_PATHFUNC_BY_IX[ix];

        int err = func( perl_nfs->nfs, path );

        if (err) {
            const char* funcname = VOID_PATHFUNC_NAME_BY_IX[ix];
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);

#line 1998 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_rmdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_rmdir)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 1544 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        const char* funcname = VOID_PATHFUNC_NAME_BY_IX[ix];

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        _nfs_async_void_pathfunc func = ASYNC_VOID_PATHFUNC_BY_IX[ix];
        int err = func( perl_nfs->nfs, path, _do_perl_callback, cb_sp );

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2035 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_mknod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_mknod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv, dev_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv = ST(2)
;
	SV*	dev_sv = ST(3)
;
#line 1562 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int mode = SvIV(mode_sv);
        int dev = SvIV(dev_sv);

        int err = nfs_mknod(perl_nfs->nfs, path, mode, dev);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "mknod", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);

#line 2072 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_mknod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_mknod)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv, dev_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv = ST(2)
;
	SV*	dev_sv = ST(3)
;
	SV*	cb = ST(4)
;
#line 1582 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int mode = SvIV(mode_sv);
        int dev = SvIV(dev_sv);

        const char* funcname = "mknod";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err = nfs_mknod_async( perl_nfs->nfs, path, mode, dev, _do_perl_callback, cb_sp );

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2113 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_opendir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_opendir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, path_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
#line 1601 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        struct nfsdir *nfsdir = { NULL };

        int err = nfs_opendir(perl_nfs->nfs, path, &nfsdir);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "opendir", err, NULL);
        }

        RETVAL = _create_perl_dh(aTHX_ self_sv, nfsdir);
#line 2145 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_opendir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_opendir)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 1620 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        const char* funcname = "opendir";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_opendir_async, self_sv);

        int err = nfs_opendir_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }

        SvREFCNT_inc(self_sv);
#line 2182 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_getcwd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_getcwd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	const char *	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1639 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char *cwd = NULL;
        nfs_getcwd( perl_nfs->nfs, &cwd );

        RETVAL = cwd;
#line 2206 "LibNFS.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_statvfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_statvfs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, path_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
#line 1651 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        struct nfs_statvfs_64 svfs;

        int err = nfs_statvfs64(perl_nfs->nfs, path, &svfs);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "statvfs", err, NULL);
        }

        RETVAL = _ptr_to_perl_statvfs_obj(aTHX_ &svfs);
#line 2241 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_statvfs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_statvfs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 1670 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        const char* funcname = "statvfs";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_statvfs64_async, NULL);

        int err = nfs_statvfs64_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2276 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_readlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, path_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
#line 1687 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        char* dest;

        int err = nfs_readlink2(perl_nfs->nfs, path, &dest);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "readlink", err, NULL);
        }

        // We could reuse dest as RETVAL’s PV, but that gets dicey because
        // we should only do that with buffers allocated by Newx, which
        // dest isn’t. So, safety first.
        //
        int len = strlen(dest);
        RETVAL = newSVpvn(dest, len);

        free(dest);

#line 2316 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_readlink)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 1714 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        const char* funcname = "readlink";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_readlink_async, NULL);

        int err = nfs_readlink_async(perl_nfs->nfs, path, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2351 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_chmod)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv = ST(2)
;
#line 1733 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int mode = SvIV(mode_sv);   // TODO

        int err;

        if (ix) {
            err = nfs_lchmod(perl_nfs->nfs, path, mode);
        }
        else {
            err = nfs_chmod(perl_nfs->nfs, path, mode);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, ix ? "lchmod" : "chmod", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 2392 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS_utime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_utime)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, atime_sv, mtime_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	atime_sv = ST(2)
;
	SV*	mtime_sv = ST(3)
;
#line 1760 "LibNFS.xs"
        _utime_ish(aTHX_ ix, self_sv, path_sv, atime_sv, mtime_sv, NULL);

        RETVAL = SvREFCNT_inc(self_sv);
#line 2421 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_utime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_utime)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 5)
       croak_xs_usage(cv,  "self_sv, path_sv, atime_sv, mtime_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	atime_sv = ST(2)
;
	SV*	mtime_sv = ST(3)
;
	SV*	cb = ST(4)
;
#line 1771 "LibNFS.xs"
        _utime_ish(aTHX_ ix, self_sv, path_sv, atime_sv, mtime_sv, cb);
#line 2449 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__async_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_chmod)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, mode_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	mode_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 1778 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        int mode = SvIV(mode_sv);   // TODO

        const char* funcname = ix ? "lchmod" : "chmod";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err;

        if (ix) {
            err = nfs_lchmod_async(perl_nfs->nfs, path, mode, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_chmod_async(perl_nfs->nfs, path, mode, _do_perl_callback, cb_sp);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2493 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_truncate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, path_sv, length_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	length_sv = ST(2)
;
#line 1803 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        uint64_t len = exs_SvUV(length_sv);   // TODO

        int err = nfs_truncate(perl_nfs->nfs, path, len);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "truncate", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 2526 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_truncate)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, length_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	length_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 1821 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);
        uint64_t len = exs_SvUV(length_sv);   // TODO

        const char* funcname = "truncate";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err = nfs_truncate_async(perl_nfs->nfs, path, len, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2564 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_chown)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, path_sv, uid_sv, gid_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	uid_sv = ST(2)
;
	SV*	gid_sv = ST(3)
;
#line 1841 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        int uid = SvIV(uid_sv);   // TODO
        int gid = SvIV(gid_sv);   // TODO

        int err;

        if (ix) {
            err = nfs_lchown(perl_nfs->nfs, path, uid, gid);
        }
        else {
            err = nfs_chown(perl_nfs->nfs, path, uid, gid);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, ix ? "lchown" : "chown", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 2609 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_chown)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 5)
       croak_xs_usage(cv,  "self_sv, path_sv, uid_sv, gid_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	path_sv = ST(1)
;
	SV*	uid_sv = ST(2)
;
	SV*	gid_sv = ST(3)
;
	SV*	cb = ST(4)
;
#line 1870 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* path = exs_SvPVbyte_nolen(path_sv);

        int uid = SvIV(uid_sv);   // TODO
        int gid = SvIV(gid_sv);   // TODO

        const char* funcname = ix ? "lchown" : "chown";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err;

        if (ix) {
            err = nfs_lchown_async(perl_nfs->nfs, path, uid, gid, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_chown_async(perl_nfs->nfs, path, uid, gid, _do_perl_callback, cb_sp);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2659 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS_symlink)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, old_sv, new_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	old_sv = ST(1)
;
	SV*	new_sv = ST(2)
;
#line 1900 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* oldname = exs_SvPVbyte_nolen(old_sv);
        const char* newname = exs_SvPVbyte_nolen(new_sv);

        int err;

        _nfs_void_2pathfunc func = VOID_2PATHFUNC_BY_IX[ix];

        err = func(perl_nfs->nfs, oldname, newname);

        if (err) {
            const char *funcname = VOID_2PATHFUNC_NAME_BY_IX[ix];

            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 2699 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__async_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__async_symlink)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, old_sv, new_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	old_sv = ST(1)
;
	SV*	new_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 1927 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);

        const char* oldname = exs_SvPVbyte_nolen(old_sv);
        const char* newname = exs_SvPVbyte_nolen(new_sv);

        _nfs_async_void_2pathfunc func = ASYNC_VOID_2PATHFUNC_BY_IX[ix];

        const char *funcname = VOID_2PATHFUNC_NAME_BY_IX[ix];

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err = func(perl_nfs->nfs, oldname, newname, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 2740 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__get_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__get_fd)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 1952 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        struct nfs_context *nfs = perl_nfs->nfs;

        RETVAL = ix ? nfs_which_events(nfs) : nfs_get_fd(nfs);
#line 2763 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__service); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__service)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, revents");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	int	revents = (int)SvIV(ST(1))
;
#line 1962 "LibNFS.xs"
        nlnfs_s* perl_nfs = exs_structref_ptr(self_sv);
        struct nfs_context *nfs = perl_nfs->nfs;

        RETVAL = nfs_service(nfs, revents);

#line 2790 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__RPC_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__RPC_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "classname");
    {
	SV *	RETVAL;
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
#line 1981 "LibNFS.xs"
        struct rpc_context *rpc = rpc_init_context();
        if (NULL == rpc) {
            croak("Failed to init libnfs rpc context");
        }

        RETVAL = exs_new_structref(nlnfs_rpc_s, classname);
        nlnfs_rpc_s* perl_rpc = exs_structref_ptr(RETVAL);

        *perl_rpc = (nlnfs_rpc_s) {
            .rpc = rpc,
            .pid = getpid(),
        };

#line 2822 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__RPC_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__RPC_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV*	self_sv = ST(0)
;
#line 2000 "LibNFS.xs"
        nlnfs_rpc_s* perl_rpc = exs_structref_ptr(self_sv);

        assert(perl_rpc);

        if (perl_rpc->pid == getpid() && PL_dirty) {
            warn("%" SVf ": DESTROY at global destruction; memory leak likely!\n", self_sv);
        }

        assert(perl_rpc->rpc);

        rpc_destroy_context(perl_rpc->rpc);
#line 2851 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__RPC__async_mount_getexports); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__RPC__async_mount_getexports)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, server_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	server_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 2015 "LibNFS.xs"
        nlnfs_rpc_s* perl_rpc = exs_structref_ptr(self_sv);

        struct rpc_context* rpc = perl_rpc->rpc;

        const char* server = exs_SvPVbyte_nolen(server_sv);

        const char* funcname = "mount_getexports";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_mount_getexports, NULL);

        int err = mount_getexports_async(rpc, server, _do_perl_rpc_callback, cb_sp);

        if (err) {
            const char* str = rpc_get_error(rpc);
            croak_sv( _create_rpc_errno(aTHX_ rpc, funcname, err, str) );
        }
#line 2887 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__RPC__get_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__RPC__get_fd)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2037 "LibNFS.xs"
        nlnfs_rpc_s* perl_rpc = exs_structref_ptr(self_sv);
        struct rpc_context *rpc = perl_rpc->rpc;

        RETVAL = ix ? rpc_which_events(rpc) : rpc_get_fd(rpc);
#line 2910 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__RPC__service); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__RPC__service)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, revents");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	int	revents = (int)SvIV(ST(1))
;
#line 2047 "LibNFS.xs"
        nlnfs_rpc_s* perl_rpc = exs_structref_ptr(self_sv);
        struct rpc_context *rpc = perl_rpc->rpc;

        RETVAL = rpc_service(rpc, revents);

#line 2937 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Dirhandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Dirhandle_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV*	self_sv = ST(0)
;
#line 2064 "LibNFS.xs"
        nlnfs_dh_s* nfs_dh = exs_structref_ptr(self_sv);

        if (!nfs_dh->closed) {
            SV* nfs_sv = nfs_dh->perl_nfs;

            nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

            nfs_closedir( perl_nfs->nfs, nfs_dh->nfsdh );
        }

        SvREFCNT_dec(nfs_dh->perl_nfs);
#line 2966 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Dirhandle_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Dirhandle_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self_sv = ST(0)
;
#line 2079 "LibNFS.xs"
        _FORBID_VOID_CONTEXT;

        nlnfs_dh_s* nfs_dh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_dh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        unsigned retcount = 0;
        struct nfsdirent* dent = nfs_readdir( perl_nfs->nfs, nfs_dh->nfsdh );
        struct nfsdirent* cur_dent = dent;

        while (cur_dent) {
            retcount++;
            if (GIMME_V != G_ARRAY) break;

            cur_dent = cur_dent->next;
        }

        if (retcount) {
            EXTEND(SP, retcount);

            unsigned retcount_copy = retcount;

            while (1) {
                mPUSHs(_ptr_to_perl_dirent_obj(aTHX_ dent));

                retcount_copy--;
                if (!retcount_copy) break;

                dent = nfs_readdir( perl_nfs->nfs, nfs_dh->nfsdh );
            }
        }

        XSRETURN(retcount);
#line 3019 "LibNFS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LibNFS__Dirhandle_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Dirhandle_seek)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, loc_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	loc_sv = ST(1)
;
#line 2118 "LibNFS.xs"
        nlnfs_dh_s* nfs_dh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_dh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        long loc = SvIV(loc_sv);    // TODO

        nfs_seekdir( perl_nfs->nfs, nfs_dh->nfsdh, loc );

        RETVAL = SvREFCNT_inc(self_sv);

#line 3051 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Dirhandle_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Dirhandle_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	long	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2136 "LibNFS.xs"
        nlnfs_dh_s* nfs_dh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_dh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        RETVAL = nfs_telldir( perl_nfs->nfs, nfs_dh->nfsdh );

        if (RETVAL < 0) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "telldir", RETVAL, NULL);
        }

#line 3083 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Dirhandle_rewind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Dirhandle_rewind)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 2156 "LibNFS.xs"
        nlnfs_dh_s* nfs_dh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_dh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        if (ix) {
            if (!nfs_dh->closed) {
                nfs_closedir( perl_nfs->nfs, nfs_dh->nfsdh );
                nfs_dh->closed = true;
            }
        }
        else {
            nfs_rewinddir( perl_nfs->nfs, nfs_dh->nfsdh );
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3120 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV*	self_sv = ST(0)
;
#line 2185 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SvREFCNT_dec(nfs_fh->perl_nfs);
#line 3141 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self_sv = ST(0)
;
#line 2192 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        int err = nfs_close(perl_nfs->nfs, nfs_fh->nfsfh);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "close", err, NULL);
        }

        XSRETURN_EMPTY;
#line 3172 "LibNFS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_close)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	cb = ST(1)
;
#line 2211 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        const char* funcname = ix ? "sync" : "close";

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ funcname, cb, _parse_fallible_empty_return, NULL);

        int err;

        if (ix) {
            err = nfs_fsync_async(perl_nfs->nfs, nfs_fh->nfsfh, _do_perl_callback, cb_sp);
        }
        else {
            err = nfs_close_async(perl_nfs->nfs, nfs_fh->nfsfh, _do_perl_callback, cb_sp);
        }

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, funcname, err, NULL);
        }
#line 3214 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_read)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, count_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	count_sv = ST(1)
;
#line 2237 "LibNFS.xs"
        RETVAL = _read_or_pread(aTHX_ self_sv, NULL, count_sv, NULL);
#line 3234 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_read)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, count_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	count_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 2244 "LibNFS.xs"
        _read_or_pread(aTHX_ self_sv, NULL, count_sv, cb);
#line 3257 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_pread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_pread)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, offset_sv, count_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	count_sv = ST(2)
;
#line 2249 "LibNFS.xs"
        RETVAL = _read_or_pread(aTHX_ self_sv, offset_sv, count_sv, NULL);
#line 3279 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_pread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_pread)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, offset_sv, count_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	count_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 2256 "LibNFS.xs"
        _read_or_pread(aTHX_ self_sv, offset_sv, count_sv, cb);
#line 3304 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 2261 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        struct nfs_stat_64 st;

        int err = nfs_fstat64(perl_nfs->nfs, nfs_fh->nfsfh, &st);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "stat", err, NULL);
        }

        RETVAL = _ptr_to_perl_stat_obj(aTHX_ &st);

#line 3337 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_stat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	cb = ST(1)
;
#line 2283 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "stat", cb, _parse_stat64_async, NULL);

        int err = nfs_fstat64_async(perl_nfs->nfs, nfs_fh->nfsfh, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "stat", err, NULL);
        }
#line 3370 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, buf_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	SV*	buf_sv = ST(1)
;
#line 2300 "LibNFS.xs"
        RETVAL = _write_or_pwrite(aTHX_ self_sv, NULL, buf_sv, NULL);

#line 3392 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_write)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, buf_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	buf_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 2308 "LibNFS.xs"
        _write_or_pwrite(aTHX_ self_sv, NULL, buf_sv, cb);
#line 3415 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_pwrite); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_pwrite)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, offset_sv, buf_sv");
    {
	int	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	buf_sv = ST(2)
;
#line 2313 "LibNFS.xs"
        RETVAL = _write_or_pwrite(aTHX_ self_sv, offset_sv, buf_sv, NULL);

#line 3439 "LibNFS.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_pwrite); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_pwrite)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, offset_sv, buf_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	buf_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 2321 "LibNFS.xs"
        _write_or_pwrite(aTHX_ self_sv, offset_sv, buf_sv, cb);
#line 3464 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_seek)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, offset_sv, whence_sv");
    {
	uint64_t	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	whence_sv = ST(2)
;
#line 2326 "LibNFS.xs"
        int64_t offset = SvIV(offset_sv);   // TODO: strict
        int whence = SvIV(whence_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        uint64_t current_offset;
        int err = nfs_lseek(perl_nfs->nfs, nfs_fh->nfsfh, offset, whence, &current_offset);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "lseek", err, NULL);
        }

        RETVAL = current_offset;

#line 3504 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_seek)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, offset_sv, whence_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	offset_sv = ST(1)
;
	SV*	whence_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 2350 "LibNFS.xs"
        int64_t offset = SvIV(offset_sv);   // TODO: strict
        int whence = SvIV(whence_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "seek", cb, _parse_lseek_async, NULL);

        int err = nfs_lseek_async(perl_nfs->nfs, nfs_fh->nfsfh, offset, whence, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "seek", err, NULL);
        }
#line 3544 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_fcntl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_fcntl)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self_sv, cmd_sv, ...");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	cmd_sv = ST(1)
;
#line 2370 "LibNFS.xs"
        enum nfs4_fcntl_op cmd = exs_SvUV(cmd_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        union fcntl_arg arg;

        _set_fcntl_arg(aTHX_ cmd, &arg, &ST(2), items - 2);

        int err = nfs_fcntl(perl_nfs->nfs, nfs_fh->nfsfh, cmd, &arg);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "fcntl", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3582 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_fcntl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_fcntl)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self_sv, cmd_sv, ...");
    {
	SV*	self_sv = ST(0)
;
	SV*	cmd_sv = ST(1)
;
#line 2395 "LibNFS.xs"
        enum nfs4_fcntl_op cmd = exs_SvUV(cmd_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        union fcntl_arg arg;

        _set_fcntl_arg(aTHX_ cmd, &arg, &ST(2), items - 3);

        SV* cb = ST(items - 1);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "fcntl", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_fcntl_async(perl_nfs->nfs, nfs_fh->nfsfh, cmd, &arg, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "fcntl", err, NULL);
        }
#line 3623 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_sync)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 2420 "LibNFS.xs"
        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        int err = nfs_fsync(perl_nfs->nfs, nfs_fh->nfsfh);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "fsync", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3653 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_truncate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, length_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	length_sv = ST(1)
;
#line 2441 "LibNFS.xs"
        uint64_t len = exs_SvUV(length_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        int err = nfs_ftruncate(perl_nfs->nfs, nfs_fh->nfsfh, len);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "ftruncate", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3689 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_truncate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, length_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	length_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 2462 "LibNFS.xs"
        uint64_t len = exs_SvUV(length_sv);

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "truncate", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_ftruncate_async(perl_nfs->nfs, nfs_fh->nfsfh, len, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "truncate", err, NULL);
        }
#line 3726 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_chmod)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self_sv, mode_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	mode_sv = ST(1)
;
#line 2481 "LibNFS.xs"
        int mode = SvIV(mode_sv);   // TODO

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        int err = nfs_fchmod(perl_nfs->nfs, nfs_fh->nfsfh, mode);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "fchmod", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3760 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_chmod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, mode_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	mode_sv = ST(1)
;
	SV*	cb = ST(2)
;
#line 2502 "LibNFS.xs"
        int mode = SvIV(mode_sv);   // TODO

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "chmod", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_fchmod_async(perl_nfs->nfs, nfs_fh->nfsfh, mode, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "chmod", err, NULL);
        }
#line 3797 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Filehandle_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle_chown)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self_sv, uid_sv, gid_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
	SV*	uid_sv = ST(1)
;
	SV*	gid_sv = ST(2)
;
#line 2521 "LibNFS.xs"
        int uid = SvIV(uid_sv);   // TODO
        int gid = SvIV(gid_sv);   // TODO

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        int err = nfs_fchown(perl_nfs->nfs, nfs_fh->nfsfh, uid, gid);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "fchown", err, NULL);
        }

        RETVAL = SvREFCNT_inc(self_sv);
#line 3834 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__Filehandle__async_chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Filehandle__async_chown)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self_sv, uid_sv, gid_sv, cb");
    {
	SV*	self_sv = ST(0)
;
	SV*	uid_sv = ST(1)
;
	SV*	gid_sv = ST(2)
;
	SV*	cb = ST(3)
;
#line 2543 "LibNFS.xs"
        int uid = SvIV(uid_sv);   // TODO
        int gid = SvIV(gid_sv);   // TODO

        nlnfs_fh_s* nfs_fh = exs_structref_ptr(self_sv);

        SV* nfs_sv = nfs_fh->perl_nfs;

        nlnfs_s* perl_nfs = exs_structref_ptr(nfs_sv);

        perl_cb_s* cb_sp = _create_callback_struct(aTHX_ "chown", cb, _parse_fallible_empty_return, NULL);

        int err = nfs_fchown_async(perl_nfs->nfs, nfs_fh->nfsfh, uid, gid, _do_perl_callback, cb_sp);

        if (err) {
            _croak_nfs_errno(aTHX_ perl_nfs->nfs, "chown", err, NULL);
        }
#line 3874 "LibNFS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LibNFS__Stat_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__Stat_dev)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	UV	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2586 "LibNFS.xs"
        struct nfs_stat_64* stat_p = exs_structref_ptr(self_sv);
        RETVAL = *( (uint64_t*) ((void*)(stat_p) + STAT64_OFFSET[ix]) );
#line 3895 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__StatVFS_bsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__StatVFS_bsize)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	UV	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2611 "LibNFS.xs"
        struct nfs_statvfs_64* p = exs_structref_ptr(self_sv);
        RETVAL = *( (uint64_t*) ((void*)(p) + STATVFS64_OFFSET[ix]) );
#line 3918 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__DirEnt_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__DirEnt_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 2625 "LibNFS.xs"
        struct nfsdirent* p = exs_structref_ptr(self_sv);
        RETVAL = p->next ? exs_new_structref(struct nfsdirent, PERL_DIRENT_NS) : &PL_sv_undef;
#line 3939 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__DirEnt_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__DirEnt_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	SV *	RETVAL;
	SV*	self_sv = ST(0)
;
#line 2633 "LibNFS.xs"
        struct nfsdirent* p = exs_structref_ptr(self_sv);
        RETVAL = newSVpv(p->name, 0);
#line 3960 "LibNFS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__DirEnt_inode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__DirEnt_inode)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	uint64_t	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2649 "LibNFS.xs"
        struct nfsdirent* p = exs_structref_ptr(self_sv);
        RETVAL = *( (uint64_t*) ((void*)(p) + DIRENT_OFFSET[2 + ix]) );
#line 3983 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__DirEnt_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__DirEnt_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	uint32_t	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2666 "LibNFS.xs"
        struct nfsdirent* p = exs_structref_ptr(self_sv);
        RETVAL = *( (uint32_t*) ((void*)(p) + DIRENT_OFFSET[3 + ix]) );
#line 4006 "LibNFS.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LibNFS__DirEnt_atime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LibNFS__DirEnt_atime)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self_sv");
    {
	NV	RETVAL;
	dXSTARG;
	SV*	self_sv = ST(0)
;
#line 2678 "LibNFS.xs"
        struct nfsdirent* p = exs_structref_ptr(self_sv);
        struct timeval* tval_p = ((void*)(p) + DIRENT_OFFSET[6 + ix]);

        RETVAL = tval_p->tv_sec + (tval_p->tv_usec / 1000000);
#line 4031 "LibNFS.c"
	XSprePUSH;
	PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Net__LibNFS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__LibNFS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("Net::LibNFS::find_local_servers", XS_Net__LibNFS_find_local_servers);
        newXS_deffile("Net::LibNFS::mount_getexports", XS_Net__LibNFS_mount_getexports);
        newXS_deffile("Net::LibNFS::new", XS_Net__LibNFS_new);
        newXS_deffile("Net::LibNFS::DESTROY", XS_Net__LibNFS_DESTROY);
        newXS_deffile("Net::LibNFS::set", XS_Net__LibNFS_set);
        newXS_deffile("Net::LibNFS::queue_length", XS_Net__LibNFS_queue_length);
        newXS_deffile("Net::LibNFS::get_readmax", XS_Net__LibNFS_get_readmax);
        newXS_deffile("Net::LibNFS::get_writemax", XS_Net__LibNFS_get_writemax);
        newXS_deffile("Net::LibNFS::get_version", XS_Net__LibNFS_get_version);
        newXS_deffile("Net::LibNFS::umask", XS_Net__LibNFS_umask);
        newXS_deffile("Net::LibNFS::mount", XS_Net__LibNFS_mount);
        newXS_deffile("Net::LibNFS::_async_mount", XS_Net__LibNFS__async_mount);
        newXS_deffile("Net::LibNFS::umount", XS_Net__LibNFS_umount);
        newXS_deffile("Net::LibNFS::_async_umount", XS_Net__LibNFS__async_umount);
        cv = newXS_deffile("Net::LibNFS::lstat", XS_Net__LibNFS_stat);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::stat", XS_Net__LibNFS_stat);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_lstat", XS_Net__LibNFS__async_stat);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::_async_stat", XS_Net__LibNFS__async_stat);
        XSANY.any_i32 = 0;
        newXS_deffile("Net::LibNFS::open", XS_Net__LibNFS_open);
        newXS_deffile("Net::LibNFS::_async_open", XS_Net__LibNFS__async_open);
        newXS_deffile("Net::LibNFS::mkdir", XS_Net__LibNFS_mkdir);
        newXS_deffile("Net::LibNFS::_async_mkdir", XS_Net__LibNFS__async_mkdir);
        cv = newXS_deffile("Net::LibNFS::chdir", XS_Net__LibNFS_rmdir);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::rmdir", XS_Net__LibNFS_rmdir);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::unlink", XS_Net__LibNFS_rmdir);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::_async_chdir", XS_Net__LibNFS__async_rmdir);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::_async_rmdir", XS_Net__LibNFS__async_rmdir);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_unlink", XS_Net__LibNFS__async_rmdir);
        XSANY.any_i32 = 2;
        newXS_deffile("Net::LibNFS::mknod", XS_Net__LibNFS_mknod);
        newXS_deffile("Net::LibNFS::_async_mknod", XS_Net__LibNFS__async_mknod);
        newXS_deffile("Net::LibNFS::opendir", XS_Net__LibNFS_opendir);
        newXS_deffile("Net::LibNFS::_async_opendir", XS_Net__LibNFS__async_opendir);
        newXS_deffile("Net::LibNFS::getcwd", XS_Net__LibNFS_getcwd);
        newXS_deffile("Net::LibNFS::statvfs", XS_Net__LibNFS_statvfs);
        newXS_deffile("Net::LibNFS::_async_statvfs", XS_Net__LibNFS__async_statvfs);
        newXS_deffile("Net::LibNFS::readlink", XS_Net__LibNFS_readlink);
        newXS_deffile("Net::LibNFS::_async_readlink", XS_Net__LibNFS__async_readlink);
        cv = newXS_deffile("Net::LibNFS::chmod", XS_Net__LibNFS_chmod);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::lchmod", XS_Net__LibNFS_chmod);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::lutime", XS_Net__LibNFS_utime);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::utime", XS_Net__LibNFS_utime);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_lutime", XS_Net__LibNFS__async_utime);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::_async_utime", XS_Net__LibNFS__async_utime);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_chmod", XS_Net__LibNFS__async_chmod);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_lchmod", XS_Net__LibNFS__async_chmod);
        XSANY.any_i32 = 1;
        newXS_deffile("Net::LibNFS::truncate", XS_Net__LibNFS_truncate);
        newXS_deffile("Net::LibNFS::_async_truncate", XS_Net__LibNFS__async_truncate);
        cv = newXS_deffile("Net::LibNFS::chown", XS_Net__LibNFS_chown);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::lchown", XS_Net__LibNFS_chown);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::_async_chown", XS_Net__LibNFS__async_chown);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_lchown", XS_Net__LibNFS__async_chown);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::link", XS_Net__LibNFS_symlink);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::rename", XS_Net__LibNFS_symlink);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::symlink", XS_Net__LibNFS_symlink);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_async_link", XS_Net__LibNFS__async_symlink);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::_async_rename", XS_Net__LibNFS__async_symlink);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::_async_symlink", XS_Net__LibNFS__async_symlink);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_get_fd", XS_Net__LibNFS__get_fd);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::_which_events", XS_Net__LibNFS__get_fd);
        XSANY.any_i32 = 1;
        newXS_deffile("Net::LibNFS::_service", XS_Net__LibNFS__service);
        newXS_deffile("Net::LibNFS::RPC::new", XS_Net__LibNFS__RPC_new);
        newXS_deffile("Net::LibNFS::RPC::DESTROY", XS_Net__LibNFS__RPC_DESTROY);
        newXS_deffile("Net::LibNFS::RPC::_async_mount_getexports", XS_Net__LibNFS__RPC__async_mount_getexports);
        cv = newXS_deffile("Net::LibNFS::RPC::_get_fd", XS_Net__LibNFS__RPC__get_fd);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::RPC::_which_events", XS_Net__LibNFS__RPC__get_fd);
        XSANY.any_i32 = 1;
        newXS_deffile("Net::LibNFS::RPC::_service", XS_Net__LibNFS__RPC__service);
        newXS_deffile("Net::LibNFS::Dirhandle::DESTROY", XS_Net__LibNFS__Dirhandle_DESTROY);
        newXS_deffile("Net::LibNFS::Dirhandle::read", XS_Net__LibNFS__Dirhandle_read);
        newXS_deffile("Net::LibNFS::Dirhandle::seek", XS_Net__LibNFS__Dirhandle_seek);
        newXS_deffile("Net::LibNFS::Dirhandle::tell", XS_Net__LibNFS__Dirhandle_tell);
        cv = newXS_deffile("Net::LibNFS::Dirhandle::close", XS_Net__LibNFS__Dirhandle_rewind);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::Dirhandle::rewind", XS_Net__LibNFS__Dirhandle_rewind);
        XSANY.any_i32 = 0;
        newXS_deffile("Net::LibNFS::Filehandle::DESTROY", XS_Net__LibNFS__Filehandle_DESTROY);
        newXS_deffile("Net::LibNFS::Filehandle::close", XS_Net__LibNFS__Filehandle_close);
        cv = newXS_deffile("Net::LibNFS::Filehandle::_async_close", XS_Net__LibNFS__Filehandle__async_close);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::Filehandle::_async_sync", XS_Net__LibNFS__Filehandle__async_close);
        XSANY.any_i32 = 1;
        newXS_deffile("Net::LibNFS::Filehandle::read", XS_Net__LibNFS__Filehandle_read);
        newXS_deffile("Net::LibNFS::Filehandle::_async_read", XS_Net__LibNFS__Filehandle__async_read);
        newXS_deffile("Net::LibNFS::Filehandle::pread", XS_Net__LibNFS__Filehandle_pread);
        newXS_deffile("Net::LibNFS::Filehandle::_async_pread", XS_Net__LibNFS__Filehandle__async_pread);
        newXS_deffile("Net::LibNFS::Filehandle::stat", XS_Net__LibNFS__Filehandle_stat);
        newXS_deffile("Net::LibNFS::Filehandle::_async_stat", XS_Net__LibNFS__Filehandle__async_stat);
        newXS_deffile("Net::LibNFS::Filehandle::write", XS_Net__LibNFS__Filehandle_write);
        newXS_deffile("Net::LibNFS::Filehandle::_async_write", XS_Net__LibNFS__Filehandle__async_write);
        newXS_deffile("Net::LibNFS::Filehandle::pwrite", XS_Net__LibNFS__Filehandle_pwrite);
        newXS_deffile("Net::LibNFS::Filehandle::_async_pwrite", XS_Net__LibNFS__Filehandle__async_pwrite);
        newXS_deffile("Net::LibNFS::Filehandle::seek", XS_Net__LibNFS__Filehandle_seek);
        newXS_deffile("Net::LibNFS::Filehandle::_async_seek", XS_Net__LibNFS__Filehandle__async_seek);
        newXS_deffile("Net::LibNFS::Filehandle::fcntl", XS_Net__LibNFS__Filehandle_fcntl);
        newXS_deffile("Net::LibNFS::Filehandle::_async_fcntl", XS_Net__LibNFS__Filehandle__async_fcntl);
        newXS_deffile("Net::LibNFS::Filehandle::sync", XS_Net__LibNFS__Filehandle_sync);
        newXS_deffile("Net::LibNFS::Filehandle::truncate", XS_Net__LibNFS__Filehandle_truncate);
        newXS_deffile("Net::LibNFS::Filehandle::_async_truncate", XS_Net__LibNFS__Filehandle__async_truncate);
        newXS_deffile("Net::LibNFS::Filehandle::chmod", XS_Net__LibNFS__Filehandle_chmod);
        newXS_deffile("Net::LibNFS::Filehandle::_async_chmod", XS_Net__LibNFS__Filehandle__async_chmod);
        newXS_deffile("Net::LibNFS::Filehandle::chown", XS_Net__LibNFS__Filehandle_chown);
        newXS_deffile("Net::LibNFS::Filehandle::_async_chown", XS_Net__LibNFS__Filehandle__async_chown);
        cv = newXS_deffile("Net::LibNFS::Stat::atime", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 10;
        cv = newXS_deffile("Net::LibNFS::Stat::atime_nsec", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 13;
        cv = newXS_deffile("Net::LibNFS::Stat::blksize", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("Net::LibNFS::Stat::blocks", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 9;
        cv = newXS_deffile("Net::LibNFS::Stat::ctime", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 12;
        cv = newXS_deffile("Net::LibNFS::Stat::ctime_nsec", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 15;
        cv = newXS_deffile("Net::LibNFS::Stat::dev", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::Stat::gid", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Net::LibNFS::Stat::ino", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::Stat::mode", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::Stat::mtime", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 11;
        cv = newXS_deffile("Net::LibNFS::Stat::mtime_nsec", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 14;
        cv = newXS_deffile("Net::LibNFS::Stat::nfs_used", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 16;
        cv = newXS_deffile("Net::LibNFS::Stat::nlink", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Net::LibNFS::Stat::rdev", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Net::LibNFS::Stat::size", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Net::LibNFS::Stat::uid", XS_Net__LibNFS__Stat_dev);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Net::LibNFS::StatVFS::bavail", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Net::LibNFS::StatVFS::bfree", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Net::LibNFS::StatVFS::blocks", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::StatVFS::bsize", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::StatVFS::favail", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Net::LibNFS::StatVFS::ffree", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Net::LibNFS::StatVFS::files", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Net::LibNFS::StatVFS::flag", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 9;
        cv = newXS_deffile("Net::LibNFS::StatVFS::frsize", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::StatVFS::fsid", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("Net::LibNFS::StatVFS::namemax", XS_Net__LibNFS__StatVFS_bsize);
        XSANY.any_i32 = 10;
        newXS_deffile("Net::LibNFS::DirEnt::next", XS_Net__LibNFS__DirEnt_next);
        newXS_deffile("Net::LibNFS::DirEnt::name", XS_Net__LibNFS__DirEnt_name);
        cv = newXS_deffile("Net::LibNFS::DirEnt::blksize", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 12;
        cv = newXS_deffile("Net::LibNFS::DirEnt::blocks", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 13;
        cv = newXS_deffile("Net::LibNFS::DirEnt::dev", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 10;
        cv = newXS_deffile("Net::LibNFS::DirEnt::inode", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::DirEnt::rdev", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 11;
        cv = newXS_deffile("Net::LibNFS::DirEnt::size", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Net::LibNFS::DirEnt::used", XS_Net__LibNFS__DirEnt_inode);
        XSANY.any_i32 = 14;
        cv = newXS_deffile("Net::LibNFS::DirEnt::atime_nsec", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 13;
        cv = newXS_deffile("Net::LibNFS::DirEnt::ctime_nsec", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 15;
        cv = newXS_deffile("Net::LibNFS::DirEnt::gid", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Net::LibNFS::DirEnt::mode", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Net::LibNFS::DirEnt::mtime_nsec", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 14;
        cv = newXS_deffile("Net::LibNFS::DirEnt::nlink", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("Net::LibNFS::DirEnt::type", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::DirEnt::uid", XS_Net__LibNFS__DirEnt_type);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Net::LibNFS::DirEnt::atime", XS_Net__LibNFS__DirEnt_atime);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Net::LibNFS::DirEnt::ctime", XS_Net__LibNFS__DirEnt_atime);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Net::LibNFS::DirEnt::mtime", XS_Net__LibNFS__DirEnt_atime);
        XSANY.any_i32 = 1;
    }

    /* Initialisation Section */

#line 1047 "LibNFS.xs"
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "_POLLIN", newSVuv(POLLIN));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "_POLLOUT", newSVuv(POLLOUT));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "NFS4_F_SETLK", newSVuv(NFS4_F_SETLK));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "NFS4_F_SETLKW", newSVuv(NFS4_F_SETLKW));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "F_RDLCK", newSVuv(F_RDLCK));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "F_WRLCK", newSVuv(F_WRLCK));
    newCONSTSUB(gv_stashpv(PERL_NS, 0), "F_UNLCK", newSVuv(F_UNLCK));

#line 4309 "LibNFS.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
